#include "custom.h"

static pin  plcc20[] =
 {
    {0,0},  {2,0},  {0,-2},
    {2,-4}, {2,-2}, {4,-4},
    {4,-2}, {6,-4}, {8,-2},
    {6,-2}, {8,0},  {6,0},
    {8,2},  {6,4},  {6,2},
    {4,4},  {4,2},  {2,4},
    {0,2},  {2,2}
 };
#define plcc20_len  sizeof(plcc20)/sizeof(plcc20[0])

static pin  plcc28[] =
 {
    {0,0},   {-2,-2}, {0,-2},
    {-2,-4}, {0,-6},  {0,-4},
    {2,-6},  {2,-4},  {4,-6},
    {4,-4},  {6,-6},  {8,-4},
    {6,-4},  {8,-2},  {6,-2},
    {8,0},   {6,0},   {8,2},
    {6,4},   {6,2},   {4,4},
    {4,2},   {2,4},   {2,2},
    {0,4},   {-2,2},  {0,2},
    {-2,0}
 };
#define plcc28_len  sizeof(plcc28)/sizeof(plcc28[0])

static pin  plcc32[] =
 {
    {0,0},   {-2,-2}, {0,-2},
    {-2,-4}, {0,-6},  {0,-4},
    {2,-6},  {2,-4},  {4,-6},
    {4,-4},  {6,-6},  {6,-4},
    {8,-6},  {10,-4}, {8,-4},
    {10,-2}, {8,-2},  {10,0},
    {8,0},   {10,2},  {8,4},
    {8,2},   {6,4},   {6,2},
    {4,4},   {4,2},   {2,4},
    {2,2},   {0,4},   {-2,2},
    {0,2},   {-2,0}
 };
#define plcc32_len  sizeof(plcc32)/sizeof(plcc32[0])

static pin  plcc44[] =
 {
    {0,0},   {-2,-2}, {0,-2},
    {-2,-4}, {0,-4},  {-2,-6},
    {0,-8},  {0,-6},  {2,-8},
    {2,-6},  {4,-8},  {4,-6},
    {6,-8},  {6,-6},  {8,-8},
    {8,-6},  {10,-8}, {12,-6},
    {10,-6}, {12,-4}, {10,-4},
    {12,-2}, {10,-2}, {12,0},
    {10,0},  {12,2},  {10,2},
    {12,4},  {10,6},  {10,4},
    {8,6},   {8,4},   {6,6},
    {6,4},   {4,6},   {4,4},
    {2,6},   {2,4},   {0,6},
    {-2,4},  {0,4},   {-2,2},
    {0,2},   {-2,0}
 };              
#define plcc44_len  sizeof(plcc44)/sizeof(plcc44[0])

static pin  plcc52[] =
 {
    {0,0},   {2,0},   {0,-2},
    {2,-2},  {0,-4},  {2,-4},
    {0,-6},  {2,-8},  {2,-6},
    {4,-8},  {4,-6},  {6,-8},
    {6,-6},  {8,-8},  {8,-6},
    {10,-8}, {10,-6}, {12,-8},
    {12,-6}, {14,-8}, {16,-6},
    {14,-6}, {16,-4}, {14,-4},
    {16,-2}, {14,-2}, {16,0},
    {14,0},  {16,2},  {14,2},
    {16,4},  {14,4},  {16,6},
    {14,8},  {14,6},  {12,8},
    {12,6},  {10,8},  {10,6},
    {8,8},   {8,6},   {6,8},
    {6,6},   {4,8},   {4,6},
    {2,8},   {0,6},   {2,6},
    {0,4},   {2,4},   {0,2},
    {2,2}
 };
#define plcc52_len  sizeof(plcc52)/sizeof(plcc52[0])

static pin  plcc68[] =
 {
    {0,0},    {2,0},    {0,-2},
    {2,-2},   {0,-4},   {2,-4},
    {0,-6},   {2,-6},   {0,-8},
    {2,-10},  {2,-8},   {4,-10},
    {4,-8},   {6,-10},  {6,-8},
    {8,-10},  {8,-8},   {10,-10},
    {10,-8},  {12,-10}, {12,-8},
    {14,-10}, {14,-8},  {16,-10},
    {16,-8},  {18,-10}, {20,-8},
    {18,-8},  {20,-6},  {18,-6},
    {20,-4},  {18,-4},  {20,-2},
    {18,-2},  {20,0},   {18,0},
    {20,2},   {18,2},   {20,4},
    {18,4},   {20,6},   {18,6},
    {20,8},   {18,10},  {18,8},
    {16,10},  {16,8},   {14,10},
    {14,8},   {12,10},  {12,8},
    {10,10},  {10,8},   {8,10},
    {8,8},    {6,10},   {6,8},
    {4,10},   {4,8},    {2,10},
    {0,8},    {2,8},    {0,6},
    {2,6},    {0,4},    {2,4},
    {0,2},    {2,2}
 };
#define plcc68_len  sizeof(plcc68)/sizeof(plcc68[0])

static pin  plcc84[] =
 {
    {0,0},    {2,0},    {0,-2},
    {2,-2},   {0,-4},   {2,-4},
    {0,-6},   {2,-6},   {0,-8},
    {2,-8},   {0,-10},  {2,-12},
    {2,-10},  {4,-12},  {4,-10},
    {6,-12},  {6,-10},  {8,-12},
    {8,-10},  {10,-12}, {10,-10},
    {12,-12}, {12,-10}, {14,-12},
    {14,-10}, {16,-12}, {16,-10},
    {18,-12}, {18,-10}, {20,-12},
    {20,-10}, {22,-12}, {24,-10},
    {22,-10}, {24,-8},  {22,-8},
    {24,-6},  {22,-6},  {24,-4},
    {22,-4},  {24,-2},  {22,-2},
    {24,0},   {22,0},   {24,2},
    {22,2},   {24,4},   {22,4},
    {24,6},   {22,6},   {24,8},
    {22,8},   {24,10},  {22,12},
    {22,10},  {20,12},  {20,10},
    {18,12},  {18,10},  {16,12},
    {16,10},  {14,12},  {14,10},
    {12,12},  {12,10},  {10,12},
    {10,10},  {8,12},   {8,10},
    {6,12},   {6,10},   {4,12},
    {4,10},   {2,12},   {0,10},
    {2,10},   {0,8},    {2,8},
    {0,6},    {2,6},    {0,4},
    {2,4},    {0,2},    {2,2},
 };
#define plcc84_len  sizeof(plcc84)/sizeof(plcc84[0])

static pin to5[]   = { {0,0}, {2,2}, {4,0} };
#define to5_len sizeof(to5)/sizeof(to5[0])

static pin to18[]  = { {0,0}, {1,1}, {2,0} };
#define to18_len sizeof(to18)/sizeof(to18[0])

static pin pot_p[] = { {0,0}, {6,-2}, {10,0} };
#define pot_p_len sizeof(pot_p)/sizeof(pot_p[0])

static pin pot_w[] = { {0,0}, {6,-4}, {10,0} };
#define pot_w_len sizeof(pot_w)/sizeof(pot_w[0])

static pin pot_y[] = { {0,0}, {8,-2}, {14,0} };
#define pot_y_len sizeof(pot_y)/sizeof(pot_y[0])

cust_table custom[] =
{
   {"PLCC20",      plcc20_len,  plcc20},
   {"PLCC28",      plcc28_len,  plcc28},
   {"PLCC32",      plcc32_len,  plcc32},
   {"PLCC44",      plcc44_len,  plcc44},
   {"PLCC52",      plcc52_len,  plcc52},
   {"PLCC68",      plcc68_len,  plcc68},
   {"PLCC84",      plcc84_len,  plcc84},
   {"TO5",         to5_len,     to5   },
   {"TO18",        to18_len,    to18  },
   {"TRIMMERW",    pot_w_len,   pot_w },
   {"TRIMMERP",    pot_p_len,   pot_p },
   {"TRIMMERY",    pot_y_len,   pot_y },
};

unsigned custom_len = sizeof(custom)/sizeof(custom[0]);
           
